routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});
Auth::routes();
//Route::get('home', 'HomeController@index')->name('home');
// Route::group(['middleware' => ['auth']], function() {
//     Route::resource('roles','RoleController');
//     Route::resource('users','UserController');
//     //Route::resource('/users','UserController',['except' => ['show','create','store']]);
// });
/********* **********/
/*formation routes*/
/********* **********/
Route::group(['prefix' => 'admin', 'as' => 'admin.', 'middleware' => ['auth']], function () {
//Route::get('/', 'HomeController@index')->name('home');
Route::get('/dashboard', 'AdminController@dashboard')->name('dashboard');
Route::resource('roles','RoleController');
Route::resource('users','UserController');
Route::resource('categories','CategoryController');
Route::resource('formations','FormationController');
Route::resource('chapitres','ChapitreController');
Route::resource('questions','QuestionController');
Route::resource('reponses','ReponseController');


// Route::get('/chapitre', 'ChapitreController@index')->name('chapitres.index');
//Route::get('user/show', 'UserController@show')->name('show');

/********* **********/
/*category routes*/
/********* **********/

Route::group(['prefix' => 'category', 'as' => 'categories.'],  function () {
    Route::get('/create','CategoryController@create')->name('create');
    Route::post('/create','CategoryController@store')->name('store');
    Route::get('/{id}/show','CategoryController@show')->name('show');
    Route::get('/{id}/delete','CategoryController@destroy')->name('destroy');
    }); 
/********* **********/
/*formation routes*/
/********* **********/

Route::group(['prefix' => 'formation', 'as' => 'formations.'],  function () {
Route::get('/create','FormationController@create')->name('create');
Route::post('/create','FormationController@store')->name('store');
Route::get('/{id}/show','FormationController@show')->name('show');
Route::get('/{id}/delete','FormationController@destroy')->name('destroy');
}); 

/********* **********/
/*chapitre routes*/
/********* **********/
Route::group(['prefix' => 'chapitre', 'as' => 'chapitres.'],  function () {
Route::get('/create','ChapitreController@create')->name('chapitres.create');
Route::post('/create','ChapitreController@store')->name('chapitres.store');
Route::get('/{id}/show','ChapitreController@show')->name('show');
Route::get('/{id}/delete','ChapitreController@destroy')->name('destroy');
});
/********* **********/
/*question routes*/
/********* **********/
Route::group(['prefix' => 'question', 'as' => 'questions.'],  function () {
    Route::get('/create','QuestionController@create')->name('questions.create');
    Route::post('/create','QuestionController@store')->name('questions.store');
    Route::get('/{id}/show','QuestionController@show')->name('show');
    Route::get('/{id}/delete','QuestionController@destroy')->name('destroy');
    });

/********* **********/
/*reponse routes*/
/********* **********/
Route::group(['prefix' => 'reponse', 'as' => 'reponses.'],  function () {
    Route::get('/create','ReponseController@create')->name('reponses.create');
    Route::post('/create','ReponseController@store')->name('reponses.store');
    Route::get('/{id}/show','ReponseController@show')->name('show');
    Route::get('/{id}/delete','ReponseController@destroy')->name('destroy');
    });


// Route::get('/role', 'RoleController@index')->name('roles.index');
// Route::get('/create','RoleController@create')->name('roles.create');
// Route::post('/create','RoleController@store')->name('roles.store');
});

app/Chapitre.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Chapitre extends Model
{
    protected $fillable = ['title','description','video_name','video_type','pause_time','path','rang','formation_id'];
  
    public function formation()
    {
        return $this->belongsTo('App\Formation');
    }
    
    public function questions()
    {
        return $this->hasMany('App\Question','chapitre_id','id');
    }

}

app/Http/Controllers/ChapitreController.php
<?php

namespace App\Http\Controllers;

use App\Chapitre;
use App\Formation;
use Illuminate\Http\Request;

class ChapitreController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $data = Chapitre::all();
        return view('admin.chapitres.index',compact('data'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $formations = Formation::all();
 
        // Envoi du formulaire
        return view('admin.chapitres.add', compact( 'formations'));

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $chapitre = new Chapitre();
        $this->validate($request, [
            'title' => 'required',
            'description' => 'required',
            'video' => 'required',        ]);
        // $request->validate([
        //     'title' => 'required',
        //     'description' => 'required',
        //     'video' => 'required',
        // ]);   
    //    //dd($request->file('video')->getRealPath());
    //    // dd($file->getClientOriginalExtension());


        $file = $request->file('video');
        $title = $request->title;
        $description = $request->description;
        $video_name = $file->getClientOriginalName();
        $video_type = $file->getMimeType();
        $path = $request->file('video')->store('videos');
        $formation_id = $request->formation_id;
        $rang = $request->rang;
        $pause_time = 0;
        $video_name = time()."_".$video_name;
        $chapitre->video_name = $video_name;
        $chapitre->title = $title; 
        $chapitre->description = $description; 
        $chapitre->video_type = $video_type;
        $chapitre->path =$path;
        $chapitre->rang = $rang;
        $chapitre->pause_time = $pause_time;
        $chapitre->formation_id = $formation_id;


       
        
    //    // dd($path);


        $file->move(public_path('videos/chapitre/'),$video_name);
        $chapitre->save();
        return redirect()->route('admin.chapitres.index');

    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Chapitre  $chapitre
     * @return \Illuminate\Http\Response
     */
    public function show(Chapitre $chapitre)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Chapitre  $chapitre
     * @return \Illuminate\Http\Response
     */
    public function edit(Chapitre $chapitre)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Chapitre  $chapitre
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Chapitre $chapitre)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Chapitre  $chapitre
     * @return \Illuminate\Http\Response
     */
    public function destroy( $id)
    {
        $chapitre = Chapitre::find($id);
        //delete
        $chapitre->delete();
        return redirect()->route('admin.chapitres.index');
    }
}

resources/views/admin/chapitres/add.blade.php
@extends('layouts.adminLayout')
@section('content')
 <!-- Content Wrapper. Contains page content -->
 <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>General Form</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">General Form</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Ajouter Chapitre</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form action="{{ route('admin.chapitres.store') }}" method="POST" enctype="multipart/form-data">
                @csrf
                <div class="card-body">
                    <div class="form-group">
                        <label for="title">Title</label>
                        <input type="text" name="title" class="form-control" id="title" placeholder="Ajoute un titre">
                        @if ($errors->has('title'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('title') }}</strong>
                                    </span>
                                @endif
                      </div>
                  <div class="form-group">
                    <label for="description">Description</label>
                    <input type="text" name="description" class="form-control" id="description" placeholder="Ajouter une description">
                  
                  </div>
                  <div class="form-group">
                    <label for="rang">Rang</label>
                    <input type="number" min="1" name="rang" class="form-control" id="rang" value="1">
                  
                  </div>
                  <div class="form-group">
                    <label for="country" class="col-md-4 control-label">Formations :</label>
                    <div class="col-md-6">
                        <select name="formation_id" id="formation_id" class="form-control">
                            @foreach($formations as $formation)
                                <option value="{{ $formation->id }}">{{ $formation->title }}</option>
                            @endforeach
                        </select>
                    </div>
                </div>


                  <div class="form-group">

                <input type="file" name="video" >
                     
                    </div>
                  </div>
                 
                

               
                <!-- /.card-body -->

                <div class="card-footer">
                    
                  <button type="submit" class="btn btn-primary">Submit</button>
                </div>


              </div>
              </form>
            </div>
           
            <!-- /.card -->
          </div>
          <!--/.col (right) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <!-- Content Wrapper. Contains page content -->
 
</div><!-- /.container-fluid -->
</section>
<!-- /.content -->
</div>

resources/views/admin/chapitres/index.blade.php
@extends('layouts.adminLayout')
@section('content')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>DataTables</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <a class="btn btn-block bg-gradient-success" href="{{ route('admin.chapitres.create') }}">
                Ajouter
              </a>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    
    <!-- Main content -->
    <section class="content">
      <div class="row">
        <div class="col-12">
          <div class="card">
            <div class="card-header">
              <h3 class="card-title">Liste des chapitres</h3>
            </div>
            <!-- /.card-header -->
            <div class="card-body">
              <table id="example2" class="table table-bordered table-hover">
                <thead>
                <tr>
                  <th>Id</th>
                  <th>title</th>
                  <th>video_name</th>
                  <th>description</th>
                  <th>Rang</th>
                  <th>Action</th>
                </tr>
                </thead>

                <tbody>
                    
                    @foreach ($data as $item)
                        
                  
                    <tr>
                    <td>{{$item -> id}}</td>
                    <td>{{$item -> title}}</td>
                      <td>{{$item -> video_name}}</td>
                      <td>{{$item -> description}}</td>
                      <td>{{$item -> rang}}</td>
                      <td>
                        <a href="{{route('admin.chapitres.show',['id'=>$item->id])}}" class = "btn btn-primary">Show</a>
                        <a href="{{route('admin.chapitres.destroy',['id'=>$item->id])}}" class = "btn btn-danger">Delete</a>
                      </td>
                      </tr>

                    @endforeach
                    </tbody>
                    <tfoot>
                    <tr>
                      
                    </tr>
                    </tfoot>
              </table>
            </div>
            <!-- /.card-body -->
          </div>
          <!-- /.card -->

         
          <!-- /.card -->
        </div>
        <!-- /.col -->
      </div>
      <!-- /.row -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  @endsection